import krister.Ess.*;
import java.util.*;

class SoundBox
{
  List<String> audio_stream_urls = null;
  AudioStream audio_stream = null;
  AudioFile audio_file = null;
  String audio_stream_url;
  boolean playing = false;
  
  SoundBox()
  {    
    this.audio_stream_urls = Collections.synchronizedList(new ArrayList<String>());    
  }
  
  void playRandomStream()
  {
    Random r = new Random();
    String n_audio_stream_url;
    if (audio_stream_urls.size() > 0) {
      n_audio_stream_url = this.audio_stream_urls.get(r.nextInt(this.audio_stream_urls.size()));
      playStream(n_audio_stream_url);
    }
  }
  
  void addStreams(List<String> n_audio_stream_urls)
  {
    this.audio_stream_urls.addAll(n_audio_stream_urls);
  }
  
  void addStream(String n_audio_stream_url)
  {
    this.audio_stream_urls.add(n_audio_stream_url);
  }
  
  void playStream(String n_audio_stream_url)
  {
    if (n_audio_stream_url.equals(""))
    {
      return;
    }
    
    this.playing = false;
    
    if (this.audio_file != null)
    {
      this.audio_file.close();
      this.audio_file = null;
    }

    if (this.audio_stream != null)
    {
      this.audio_stream.stop();
      this.audio_stream = null;
    }
    this.audio_stream_url = n_audio_stream_url;
    audio_file = new AudioFile(this.audio_stream_url, 0, Ess.READ);
     
    // create a new AudioStream and set the sample rate
    if (audio_stream == null)
    {
      audio_stream = new AudioStream();
    }
    audio_stream.sampleRate(audio_file.sampleRate);
    audio_stream.start();    
    this.playing = true;
  }
  
  public void readNext()
  {
    if (this.playing) {
      // read the next chunk    
      int samplesRead = this.audio_file.read(this.audio_stream);
      if (samplesRead == 0) 
      {
        // start over
        this.audio_file.close();
        this.audio_file.open(this.audio_stream_url, this.audio_stream.sampleRate, Ess.READ);
        samplesRead = this.audio_file.read(this.audio_stream);
      }
    } 
  }
  
  boolean isActive()
  {
    return (audio_file != null);
  }  
}
